package com.cusc.adas.v2x.vo;

import java.util.List;

import com.cusc.adas.v2x.utils.FieldDef;
import com.cusc.adas.v2x.utils.NumFlag;
import com.cusc.adas.v2x.utils.Order;
import com.cusc.adas.v2x.utils.RefNumFlag;

/**
 * 车辆辅助驾驶信息及状态信息
 * @author huangml
 *
 */
public class VehicleStatusInfo {
	@Order(1)
	//ABS 状态
	private short absFlag;
	//TCS 状态
	@Order(2)
	private short tcsFlag;
	//ESP 状态
	@Order(3)
	private short espFlag;
	//LKA 状态
	@Order(4)
	private short lkaFlag;
	//ACC 工作模式
	@Order(5)
	private short accMode;
	
	
	//FCW 状态
	@Order(6)
	private short fcwFlag;
	
	
	//LDW 状态
	@Order(7)
	private short ldwFlag;
	//AEB 状态
	@Order(8)
	private short aebFlag;
	//LCA 状态
	@Order(9)
	private short lcaFlag;
	//DMS 状态
	@Order(10)
	private short dmsFlag;
	//里程
	@Order(11)
	private short mileage;
	//sweeping状态
	@Order(12)
	private short sweepingFlag;
	//watering状态
	@Order(13)
	private short wateringFlag;
	//油量
	@Order(14)
	private int fuelGauge;
	//电池剩余电量
	@Order(15)
	private int soc;
	//电池温度
	@Order(16)
	private short temperature;
	
	//预计续航里程
	@Order(17)
	private float endurance;
	
	//车辆故障状态
	@Order(18)
	private int vehFault;
	
	//电机转速
	@Order(19)
	private int motorspeed;
	//电机转矩
	@Order(20)
	private long motortorque;
	//运行模式
	@Order(21)
	private short vehMode;
	
	//充电状态
	@Order(22)
	private short chargeState;
	//动力电池实时电压
	@Order(23)
	private int battVol;
	//动力电池实时电流
	@Order(24)
	private int battCur;
	
	//喇叭状态
	@Order(25)
	private short hornState;
	//车轮数
	@Order(26)
	@NumFlag
	private short  wheelNum;
	//轮速
	@Order(27)
	@RefNumFlag(value="wheelNum")
	private int[]  wheelVelocity;
	//胎压
	@Order(28)
	@RefNumFlag(value="wheelNum")
	private int[]  tirePressure;
	//车灯状态
	@Order(30)
	private int lights;
	//车门状态
	@Order(31)
	private int doors;
	//自定义字段长度
	@Order(32)
	@NumFlag
	private short userdefinedDataLength;
	//自定义字段内容
	@Order(33)
	@RefNumFlag(value="userdefinedDataLength")
	@FieldDef(type="BYTE",isAutoLength=true)
	private String userdefinedData;
	
}
